package  
{
	import mx.controls.TextArea;	
	import mx.events.FlexEvent;	
	
	import flash.geom.ColorTransform;	
	import flash.geom.Transform;	
	import flash.events.Event;	
	
	import mx.controls.HSlider;	
	import mx.controls.Image;	
	import mx.core.Application;
	
	/**
	 * @author Kelvin Luck
	 */
	public class ColorTransformExplorerClass extends Application 
	{
		
		public var dirtyImage:Image;
		
		public var outputText:TextArea;

		public var redMultiplier:HSlider;
		public var greenMultiplier:HSlider;
		public var blueMultiplier:HSlider;
		public var redOffset:HSlider;
		public var greenOffset:HSlider;
		public var blueOffset:HSlider;
		
		[Embed(source="3267835576_57613e021b.jpg")]
		private var embeddedImage:Class;

		public function ColorTransformExplorerClass()
		{
			super();
			addEventListener(FlexEvent.CREATION_COMPLETE, onCreationComplete);
		}

		override protected function createChildren():void
		{
			super.createChildren();
			redMultiplier.addEventListener(Event.CHANGE, onSlidersChange);
			greenMultiplier.addEventListener(Event.CHANGE, onSlidersChange);
			blueMultiplier.addEventListener(Event.CHANGE, onSlidersChange);
			redOffset.addEventListener(Event.CHANGE, onSlidersChange);
			greenOffset.addEventListener(Event.CHANGE, onSlidersChange);
			blueOffset.addEventListener(Event.CHANGE, onSlidersChange);
		}
		
		private function onCreationComplete(event:FlexEvent):void
		{
			dirtyImage.data = new embeddedImage();
			onSlidersChange();
		}

		private function onSlidersChange(event:Event=null):void
		{
			var t:Transform = new Transform(dirtyImage);
			t.colorTransform = new ColorTransform(redMultiplier.value, greenMultiplier.value, blueMultiplier.value, 1, redOffset.value, greenOffset.value, blueOffset.value);
			outputText.text = "new ColorTransform(" + redMultiplier.value + ", " + greenMultiplier.value + ", " + blueMultiplier.value + ", 1, " + redOffset.value + ", " + greenOffset.value + ", " + blueOffset.value + ");";
			
		}
	}
}
